C ********************************************************************
C * EDiT - Electronic Dipole-induced Transitions                     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  CHARACTER*(*) FUNCTION LCASE                                    *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Converts the characters in a string to lower case. * 
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: October 1995                                       *
C *  Revision...:                                                    * 
C *                                                                  *
C *  Called from: GETSEL                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      CHARACTER*(*) FUNCTION LCASE(STRING,LEN)

      IMPLICIT NONE

        CHARACTER*(*) STRING
        INTEGER LEN

C VAR
      INTEGER ILOWA, ICAPA, ICAPZ
C      PARAMETER(ILOWA=ICHAR('a'), ICAPA=ICHAR('A'), ICAPZ=ICHAR('Z'))

      INTEGER I

C BEGIN
      ILOWA=ICHAR('a')
      ICAPA=ICHAR('A')
      ICAPZ=ICHAR('Z')

      DO 10 I = 1, LEN
        IF ( (ICHAR(STRING(I:I)) .GE. ICAPA) .AND. 
     .       (ICHAR(STRING(I:I)) .LE. ICAPZ) ) THEN
          STRING(I:I) = CHAR(ILOWA + ICHAR(STRING(I:I)) - ICAPA)
        ENDIF
10    CONTINUE
      
      LCASE = STRING

      RETURN
      END
C END
