C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE FMOR                                                 *
C *                                                                  *
C *  Routine of ICONC                                                *
C *                                                                  *
C *  Usage......: does icon piece on fragments.                      *
C *                                                                  *
C *  Author ....: Charles Wilker (R. Hoffmann group)                 *
C *  Date.......: December 1981                                      *
C *  Revision...: last revision 24.08.97/mbs (Martin Braendle)       *
C *  Available..: Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *  Remarks....: Adapted from the BIGICON version.                  *
C *                                                                  *
C *  Called from: HUCKEL                                             *
C *                                                                  *
C *  Calls......: OCC                                                *
C *               INPRT                                              *
C *               OVPRT                                              *
C *               HUCK                                               *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE FMOR(H1,S1,MAD,C,SP,COUL0,W,IOCC,HDG,
     . NDIM,NC,NATOM,NTYPE,NHDG,ND1,NUMB)
 
      INCLUDE 'iconpara.for'
 
      IMPLICIT REAL*8(A-H,O-Z)
 
      INTEGER ND1
      DIMENSION H1(ND1,ND1),S1(ND1,ND1)
      DIMENSION MAD(NTYPE,NTYPE),C(NC),SP(NDIM),COUL0(NDIM),W(NDIM),
     . IOCC(NDIM),HDG(NHDG)
      REAL*8 MAD
      REAL*4 IOCC
 
      COMMON /ATOM/EXPS(MXATOM),EXPP(MXATOM),EXPD(MXATOM),EXPD2(MXATOM),
     .             C1(MXATOM),C2(MXATOM),COULS(MXATOM),COULP(MXATOM),
     .             COULD(MXATOM),X(MXATOM),Y(MXATOM),Z(MXATOM),
     .             KEY(MXATOM),AC(MXATOM),VELEC(MXATOM),NS(MXATOM),
     .             NP(MXATOM),ND(MXATOM)
      INTEGER AC,VELEC,KEY
 
      COMMON/CNTRL/CON,PEEP,COULH,NH,NA,NATM,KA,NELEC,METH,
     . IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
      LOGICAL*1 L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
 
      COMMON/FMO/FMO(MXATOM),FMOCH(9),SORA(MXATOM),SORB(MXATOM),
     .           NFRAG(9),NUMBAT(9),IFMOPT(4*MXATOM),IBCKPT(MXATOM),
     .           PRIFMO(7)
      INTEGER FMO,FMOCH,SORA,SORB
      LOGICAL*1 PRIFMO
 
      LOGICAL FLAG
      INTEGER*4 NDC
 
C
C  LOAD UP ATOM2 FOR OUTPUT
C
      ICNT=0
      DO 10 I=1,NATOM
        IF (FMO(I) .NE. NUMB) GOTO 10
        ICNT=ICNT+1
        KEY(ICNT)=AC(I)
        IBCKPT(ICNT)=I
        SORB(ICNT+1)=SORB(ICNT)+(SORA(I+1)-SORA(I))
        ICNT2=SORB(ICNT)
        DO 5 J=SORA(I),SORA(I+1)-1          
          IFMOPT(ICNT2)=J
          ICNT2=ICNT2+1
 5      CONTINUE        
10    CONTINUE
      NA=NUMBAT(NUMB)
C
C  FIND TOTAL NUMBER OF ELECTRONS AND FILL IOCC
C
      CALL OCC(IOCC, ND1,NA,FMOCH(NUMB),NELEC)
 
      NDC=ND1*(ND1+1)/2
 
      WRITE(6,20) NUMB
20    FORMAT('1',/,' ',50('*'),' FRAGMENT',I2,' ',50('*'),/)
C
C  PRINT INPUT PARAMETERS
C
      IFMOCH=FMOCH(NUMB)
      CALL INPRT(NA,IFMOCH,NUMB)
C
C  PRINT OVERLAP AND DISTANCE MATRICES
C
      FLAG=.FALSE.
      NDIM1=ND1
      CALL OVPRT(S1,MAD,C, NDIM1,NDC,NA,NTYPE,FLAG)
C
C  DO REMAINDER OF ICON CALCULATION
C
      CALL HUCK(H1,S1,MAD,C,SP,COUL0,W,IOCC,HDG, NDIM1,NDC,NA,NTYPE,
     .          NHDG)
C
      RETURN
      END
