C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE ITRATE                                               *
C *                                                                  *
C *  Routine of ICONC(S)                                             *
C *                                                                  *
C *  Usage......: Sets up huckel matrix when using charge iteration  *
C *               (METH=2 or 3).                                     *
C *                                                                  *
C *  Authors....: -                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: last revision 04.05.93/mbs (Martin Braendle)       *
C *  Remarks....: Arrays X,Y,Z changed to HSS,HPP,HDD.               *
C *                                                                  *
C *  Called from: HUCK                                               *
C *                                                                  *
C *  Calls......: NEWDIA                                             *
C *                                                                  *
C ********************************************************************

      SUBROUTINE ITRATE(H,U,MAD,C,E,W,IOCC,HDG,NDIM,NTYPE,NC,NHDG)

      INCLUDE 'iconpara.for'
      IMPLICIT REAL*8(A-H,O-Z)

      DIMENSION H(NDIM,NDIM),U(NDIM,NDIM),MAD(NTYPE,NTYPE),C(NC),
     .          E(NDIM),W(NDIM),IOCC(NDIM),HDG(NHDG)
      REAL*8 MAD
      REAL*4 IOCC

      COMMON /ANEWDI/CWK,CWKALP,R(MXATOM,MXATOM)

      COMMON /TITLE/AB(10)

      COMMON /ATOM/EXPS(MXATOM),EXPP(MXATOM),EXPD(MXATOM),EXPD2(MXATOM),
     .             C1(MXATOM),C2(MXATOM),COULS(MXATOM),COULP(MXATOM),
     .             COULD(MXATOM),X(MXATOM),Y(MXATOM),Z(MXATOM),
     .             KEY(MXATOM),AC(MXATOM),VELEC(MXATOM),NS(MXATOM),
     .             NP(MXATOM),ND(MXATOM)
      INTEGER AC,VELEC,KEY

      COMMON /CNTRL/CON,PEEP,COULH,NH,NA,NATM,KA,NELEC,METH,IPRINT,
     .              IPUNCH,L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
      LOGICAL*1 L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT

      COMMON /OUT/PRT(24),PUN(24),IOVPOP(24),IENRGY(24)
      LOGICAL*1 PRT,PUN
      INTEGER   IOVPOP,IENRGY

      COMMON /STARS/STAR,STAR2,SYMBOL(MXATOM)
      CHARACTER*2 STAR,STAR2,SYMBOL

      COMMON /ITPARM/DAMP1,DAMP2,DAMP3,LAMPRI,DELTAC,SENSE,MAXCYC,
     .               PRTCYC,ICYCLE,NCON,PARTIT,PRINTX,ITABLE(MXITER)
      REAL*8    LAMPRI
      LOGICAL*1 PARTIT,PRINTX,ITABLE
      INTEGER*4 PRTCYC

      COMMON /ENERGY/HSS(MXATOM),HPP(MXATOM),HDD(MXATOM)
C
C Since the internal atomic parameters ( EXPS,EXPP, etc. ) are not used
C when doing charge iteration, the space allocated to them has been
C used for the VSIE parameters.
C
C obsolete, 7.12.95/mbs
C
C      DIMENSION AS1(MXITER),BS1(MXITER),CS1(MXITER),AP1(MXITER),
C     .          BP1(MXITER),CP1(MXITER),AD1(MXITER),BD1(MXITER),
C     .          CD1(MXITER)
C      REAL*4    ZS(MXITER),ZP(MXITER),ZD(MXITER)
C      EQUIVALENCE (AS1(1),EXPS(MXITER+1)),(BS1(1),EXPP(MXITER+1)),
C     .            (CS1(1),EXPD(MXITER+1)),(AP1(1),EXPD2(MXITER+1)),
C     .            (BP1(1),C1(MXITER+1)),(CP1(1),C2(MXITER+1)),
C     .            (AD1(1),COULS(MXITER+1)),(BD1(1),COULP(MXITER+1)),
C     .            (CD1(1),COULD(MXITER+1))
C      EQUIVALENCE (ZS(1),NS(MXITER+1)),(ZP(1),NP(MXITER+1)),
C     .            (ZD(1),ND(MXITER+1))
C
C      COMMON /ABC/AS2(MXITER),BS2(MXITER),CS2(MXITER),AP2(MXITER),
C     .            BP2(MXITER),CP2(MXITER),AD2(MXITER),BD2(MXITER),
C     .            CD2(MXITER),AS3(MXITER),BS3(MXITER),CS3(MXITER),
C     .            AP3(MXITER),BP3(MXITER),CP3(MXITER),AD3(MXITER),
C     .            BD3(MXITER),CD3(MXITER)
c
C COMMON block corrected, 7.12.95/mbs
C
      COMMON /ABC/AS1(MXITER),BS1(MXITER),CS1(MXITER),AP1(MXITER),
     .            BP1(MXITER),CP1(MXITER),AD1(MXITER),BD1(MXITER),
     .            CD1(MXITER),AS2(MXITER),BS2(MXITER),CS2(MXITER),
     .            AP2(MXITER),BP2(MXITER),CP2(MXITER),AD2(MXITER),
     .            BD2(MXITER),CD2(MXITER),AS3(MXITER),BS3(MXITER),
     .            CS3(MXITER),AP3(MXITER),BP3(MXITER),CP3(MXITER),
     .            AD3(MXITER),BD3(MXITER),CD3(MXITER),ZS(MXITER),
     .            ZP(MXITER),ZD(MXITER)

      EQUIVALENCE (PEEP,ADJUST),(COULH,SIGNN),(SENSE,DENSE),
     .            (VELEC(MXITER+1),DCHG),(PRT(1),NMIN),(PUN(1),NLN)

      DIMENSION F(6)
      EQUIVALENCE (A1,F(1)),(A2,F(3)),(A3,F(5))

      DIMENSION IL(3),JL(3)
      REAL*8 LAMBDA

      QON=DBLE(KA)/DBLE(NELEC)
      IF (ICYCLE .GT. 1) GOTO 120
      WRITE (6,10)
   10 FORMAT('1')
      DO 20 I=1,NDIM
        NMIN=I
        IF (IOCC(I) .GT. 0.0001) GOTO 30
   20 CONTINUE
C
C
C If charge iteration with madelung correction (METH=2) is being used,
C compute the total orbital occupations for the free atoms. Fill atomic
C orbitals in order: 1s 2s 2p 3s 3p 3d 4s 4p 4d 5s 5p 5d 6s 6p.
C
   30 IF (METH .LT. 3) GOTO 120
      DO 110 I=1,NA
        KEYI=KEY(I)
        J=NP(KEYI)
        IF (J .EQ. 0) GOTO 50
        IL(2)=J*10+1
        JL(2)=2
        J=NS(KEYI)
        IL(1)=J*10
        JL(1)=1
        J=ND(KEYI)
        IF (J .EQ. 0) GOTO 60
        IL(3)=J*10+2
        JL(3)=3
        DO 40 J=2,3
          IJ=4-J
          K=IJ+1
          DO 40 L=1,IJ
            N=K-L
            IF (IL(K) .GT. IL(N)) GOTO 40
            I1=IL(K)
            J1=JL(K)
            IL(K)=IL(N)
            JL(K)=JL(N)
            IL(N)=I1
            JL(N)=J1
   40   CONTINUE
        GOTO 70
   50   JL(1)=1
        JL(2)=2
        JL(3)=3
        GOTO 70
   60   JL(3)=3
        IF (IL(1) .LT. IL(2)) GOTO 70
        JL(2)=1
        JL(1)=2
   70   L=VELEC(KEYI)
        DO 110 J=1,3
          K=JL(J)
          J1=4*(K-1)+2
          IF (L .LT. J1) J1=L
          L=L-J1
          IF (K-2) 80,90,100
   80     ZS(KEYI)=FLOAT(J1)
          GOTO 110
   90     ZP(KEYI)=FLOAT(J1)
          GOTO 110
  100     ZD(KEYI)=FLOAT(J1)
  110 CONTINUE
  120 IF (PRINTX) WRITE (6,130)
  130 FORMAT(////)
      PRINTX=((ICYCLE/PRTCYC)*PRTCYC .EQ. ICYCLE)
      IF (ICYCLE .EQ. MAXCYC) PRINTX=.TRUE.
C
C  Calculate sum of one-electron energies.
C
      SUM=0.0D0
      DO 140 I=1,NDIM
        W(I)=DBLE(IOCC(I))
        SUM=SUM+E(I)*W(I)
  140 CONTINUE
C
C Compute atomic orbital occupations and store in E(I).
C
      IJ=1
      DO 170 I=1,NDIM
        E(I)=0.0D0
        DO 170 J=1,I
          UB=0.0D0
          DO 150 K=NMIN,NDIM
  150     UB=UB+H(I,K)*H(J,K)*W(K)
          UB=UB*0.50D0
          IF (I .EQ. J) GOTO 160
          UB=(UB+UB)*C(IJ)
          IJ=IJ+1
  160     E(I)=E(I)+UB
          E(J)=E(J)+UB
  170 CONTINUE
C
C Compute the orbital occupation of a given type (s,p,d) which varies
C most from the last cycle.
C
      DENOM=0.0D0
      DENSE2=DENSE
      DCHG2=DCHG
      J=1
      DO 200 I=1,NA
        KEYI=KEY(I)
        SDENSE=E(J)
        SIGNS=SDENSE-HSS(I)
        C(J)=SIGNS
        DIFFS=DABS(SIGNS)
        N=J
        IF (DENOM .GT. DIFFS) GOTO 180
        DENSE=HSS(I)
        DCHG=SIGNS
        DENOM=DIFFS
        NLF=10*I
  180   IF (NP(KEYI) .EQ. 0) GOTO 200
        PDENSE=E(J+1)+E(J+2)+E(J+3)
        SIGNP=PDENSE-HPP(I)
        C(J+3)=SIGNP
        DIFFP=DABS(SIGNP)
        N=J+3
        IF (DENOM .GT. DIFFP) GOTO 190
        DENSE=HPP(I)
        DCHG=SIGNP
        DENOM=DIFFP
        NLF=10*I+1
  190   IF (ND(KEYI) .EQ. 0) GOTO 200
        DDENSE=E(J+4)+E(J+5)+E(J+6)+E(J+7)+E(J+8)
        SIGND=DDENSE-HDD(I)
        C(J+8)=SIGND
        DIFFD=DABS(SIGND)
        N=J+8
        IF (DENOM .GT. DIFFD) GOTO 200
        DENSE=HDD(I)
        DCHG=SIGND
        DENOM=DIFFD
        NLF=10*I+2
  200 J=N+1

      SIGNF=DCHG/DENOM
C
C Determine lambda, the damping factor.
C
      IF (ICYCLE .LE. 2) SIGNN=SIGNF
      IF (ICYCLE .LE. 2) NLN=NLF
      ISIGNN=SIGNN
      ISIGNF=SIGNF
      IF (ICYCLE .EQ. 2) ADJUST=DAMP1*DENOM
      IF (ISIGNN .EQ. ISIGNF .OR. NLN .NE. NLF) GOTO 220
      IF (DAMP3 .NE. 0.0D0) GOTO 210
      LAMBDA=(DENSE2-DENSE)/(DCHG-DCHG2)
      GOTO 230
  210 ADJUST=DAMP3*ADJUST
  220 IF ((ADJUST/DENOM) .GE. LAMPRI) ADJUST=DAMP2*DENOM
      IF (ICYCLE .EQ. 1) ADJUST=DENOM
      LAMBDA=ADJUST/DENOM
  230 SIGNN=SIGNF
      NLN=NLF
C
C  In this section of the program three calculations are performed:
C
C  1. The total orbital occupations of a given type (s,p,d) are damped
C     and stored (in HSS(I),HPP(I),HDD(I) respectively).
C  2. The net charges are calculated and stored in C(I).
C  3. -VSIE's are calculated and stored in W(I).
C
      J=1
      DO 320 I=1,NA
        KEYI=KEY(I)
        SDENSE=HSS(I)+LAMBDA*C(J)
        HSS(I)=SDENSE
        UB=SDENSE
        N=J
        IF (NP(KEYI) .EQ. 0) GOTO 240
        PDENSE=HPP(I)+LAMBDA*C(J+3)
        HPP(I)=PDENSE
        UB=UB+PDENSE
        N=J+3
        IF (ND(KEYI) .EQ. 0) GOTO 260
        N=J+8
        DDENSE=HDD(I)+LAMBDA*C(J+8)
        HDD(I)=DDENSE
        UB=UB+DDENSE
        GOTO 280
  240   Q=VELEC(KEYI)-UB
        IF ( .NOT. PARTIT) GOTO 250
        IF (ITABLE(KEYI)) GOTO 250
        W(J)=COULS(KEYI)
        GOTO 310
  250   KEYI=MXITER+1-KEY(I)

        W(J)=-(AS1(KEYI)*Q*Q+BS1(KEYI)*Q+CS1(KEYI))
        GOTO 310
  260   Q=VELEC(KEYI)-UB
        IF ( .NOT. PARTIT) GOTO 270
        IF (ITABLE(KEYI)) GOTO 270
        W(J)=COULS(KEYI)
        W(J+1)=COULP(KEYI)
        W(J+2)=COULP(KEYI)
        W(J+3)=COULP(KEYI)
        GOTO 310
  270   KEYI=MXITER+1-KEY(I)
        VSIES1=AS1(KEYI)*Q*Q+BS1(KEYI)*Q+CS1(KEYI)
        W(J)=-VSIES1
        VSIEP1=AP1(KEYI)*Q*Q+BP1(KEYI)*Q+CP1(KEYI)
        W(J+1)=-VSIEP1
        W(J+2)=-VSIEP1
        W(J+3)=-VSIEP1
        GOTO 310
  280   Q=VELEC(KEYI)-UB
        IF ( .NOT. PARTIT) GOTO 290
        IF (ITABLE(KEYI)) GOTO 290
        W(J)=COULS(KEYI)
        W(J+1)=COULP(KEYI)
        W(J+2)=COULP(KEYI)
        W(J+3)=COULP(KEYI)
        W(J+4)=COULD(KEYI)
        W(J+5)=COULD(KEYI)
        W(J+6)=COULD(KEYI)
        W(J+7)=COULD(KEYI)
        W(J+8)=COULD(KEYI)
        GOTO 310
  290   IF (ND(KEYI) .EQ. NP(KEYI)) GOTO 300
        IF (NCON .NE. 3) GOTO 300
        KEYI=MXITER+1-KEY(I)
        VSIES1=AS1(KEYI)*Q*Q+BS1(KEYI)*Q+CS1(KEYI)
        VSIES2=AS2(KEYI)*Q*Q+BS2(KEYI)*Q+CS2(KEYI)
        VSIES3=AS3(KEYI)*Q*Q+BS3(KEYI)*Q+CS3(KEYI)
        W(J)=(SDENSE+PDENSE-2.0D0)*VSIES1+(1.0D0-SDENSE)*VSIES2-
     .       PDENSE*VSIES3
        VSIEP1=AP1(KEYI)*Q*Q+BP1(KEYI)*Q+CP1(KEYI)
        VSIEP2=AP2(KEYI)*Q*Q+BP2(KEYI)*Q+CP2(KEYI)
        VSIEP3=AP3(KEYI)*Q*Q+BP3(KEYI)*Q+CP3(KEYI)
        W(J+1)=(SDENSE+PDENSE-2.0D0)*VSIEP1+(1.0D0-PDENSE)*VSIEP2 -
     .          SDENSE*VSIEP3
        W(J+2)=W(J+1)
        W(J+3)=W(J+1)
        VSIED1=AD1(KEYI)*Q*Q+BD1(KEYI)*Q+CD1(KEYI)
        VSIED2=AD2(KEYI)*Q*Q+BD2(KEYI)*Q+CD2(KEYI)
        VSIED3=AD3(KEYI)*Q*Q+BD3(KEYI)*Q+CD3(KEYI)
        W(J+4)=(SDENSE+PDENSE-1.0D0)*VSIED1-SDENSE*VSIED2-PDENSE*VSIED3
        W(J+5)=W(J+4)
        W(J+6)=W(J+4)
        W(J+7)=W(J+4)
        W(J+8)=W(J+4)
        GOTO 310
  300   KEYI=MXITER+1-KEY(I)
        VSIES1=AS1(KEYI)*Q*Q+BS1(KEYI)*Q+CS1(KEYI)
        W(J)=-VSIES1
        VSIEP1=AP1(KEYI)*Q*Q+BP1(KEYI)*Q+CP1(KEYI)
        W(J+1)=-VSIEP1
        W(J+2)=W(J+1)
        W(J+3)=W(J+1)
        VSIED1=AD1(KEYI)*Q*Q+BD1(KEYI)*Q+CD1(KEYI)
        W(J+4)=-VSIED1
        W(J+5)=W(J+4)
        W(J+6)=W(J+4)
        W(J+7)=W(J+4)
        W(J+8)=W(J+4)
  310   J=N+1
        C(I)=Q
  320 CONTINUE
C
C If charge iteration without madelung correction (METH=2) is being
C used, setup huckel matrix, otherwise skip this section.
C
      IF (METH .GT. 2) GOTO 370
      CNST=CON
      IF (IPUNCH .EQ. 0) GOTO 340
      DO 330 I=1,NDIM
        H(I,I)=W(I)
  330 CONTINUE
      CALL NEWDIA(H,U,NDIM)
      GOTO 510
  340 CONTINUE
      H(1,1)=W(1)
      DO 360 I=2,NDIM
        H(I,I)=W(I)
        J1=I-1
        DO 360 J=1,J1
          UB=W(I)+W(J)
          IF ( .NOT. L5) GOTO 350
          UC=(W(I)-W(J))/UB
          UC=UC*UC
          CNST=CON+UC/2.0D0+UC*UC*(0.5D0-CON)
  350     UB=CNST*U(I,J)*UB
          H(J,I)=UB
  360 H(I,J)=UB
      GOTO 510
C
C  If charge iteration with madelung correction (METH=2) is being used,
C  setup huckel matrix. otherwise skip this section.
C
  370 DGSUM=0.0D0
      N=1
      M=1
      DO 420 I=1,NA
        KEYI=KEY(I)
        N1=N
        IF (NP(KEYI) .NE. 0) N1=N+1
        IF (ND(KEYI) .NE. 0) N1=N+2
        DO 410 J=N,N1
          DG1=0.0D0
          DG2=0.0D0
          L=1
          DO 390 K=1,NA
            KEYK=KEY(K)
            UB=(HSS(K)-DBLE(ZS(KEYK)))*MAD(J,L)
            UC=HSS(K)*MAD(J,L)
            L=L+1
            IF (NP(KEYK) .EQ. 0) GOTO 380
            UB=UB+(HPP(K)-DBLE(ZP(KEYK)))*MAD(J,L)
            UC=UC+HPP(K)*MAD(J,L)
            L=L+1
            IF (ND(KEYK) .EQ. 0) GOTO 380
            UB=UB+(HDD(K)-DBLE(ZD(KEYK)))*MAD(J,L)
            UC=UC+HDD(K)*MAD(J,L)
            L=L+1
  380       IF (K .NE. I) DG1=DG1+UB
  390     DG2=DG2+UC
          J1=M+2*(J-N)
          DO 400 L=M,J1
            H(L,L)=W(L)+DG1
            IF (L5) HDG(L)=H(L,L)+QON*DG2
            W(L)=DG2
  400     DGSUM=DGSUM+DG2
  410   M=J1+1
  420 N=N1+1
      CNST=CON
      DO 440 I=2,NDIM
        J1=I-1
        DO 440 J=1,J1
          IF ( .NOT. L5) GOTO 430
          UB=(HDG(I)-HDG(J))/(HDG(I)+HDG(J))
          UB=UB*UB
          CNST=CON+UB/2.0D0+UB*UB*(0.5D0-CON)
  430     UB=U(I,J)*(CNST*(H(I,I)+H(J,J))-QON*(0.5D0-CNST)*(W(I)+W(J)))
          H(I,J)=UB
  440 H(J,I)=UB
      DGSUM=-(QON*DGSUM)/DBLE(NDIM)
C
C If doing last cycle calculate energy corrections.
C
      IF (ICYCLE .NE. MAXCYC) GOTO 510
      N=1
      UB=0.0D0
      UC=0.0D0
      DO 490 I=1,NA
        KEYI=KEY(I)
        K=N
        A1=HSS(I)
        E(1)=DBLE(ZS(KEYI))
        UB=UB-0.5D0*(A1*A1-A1)*MAD(N,N)
        IF (NP(KEYI) .EQ. 0) GOTO 450
        N=N+1
        A2=HPP(I)
        E(3)=DBLE(ZP(KEYI))
        UB=UB-0.5D0*(A2*A2-A2)*MAD(N,N)-A1*A2*MAD(N-1,N)
        IF (ND(KEYI) .EQ. 0) GOTO 450
        N=N+1
        A3=HDD(I)
        E(5)=DBLE(ZD(KEYI))
        UB=UB-0.5D0*(A3*A3-A3)*MAD(N,N)-A1*A3*MAD(N-2,N)-
     .     A2*A3*MAD(N-1,N)
  450   M=1
        I1=I-1
        IF (I1 .EQ. 0) GOTO 490
        DO 480 J=1,I1
          KEYJ=KEY(J)
          L=M
          F(2)=HSS(J)
          E(2)=DBLE(ZS(KEYJ))
          IF (NP(KEYJ) .EQ. 0) GOTO 460
          M=M+1
          F(4)=HPP(J)
          E(4)=DBLE(ZP(KEYJ))
          IF (ND(KEYJ) .EQ. 0) GOTO 460
          M=M+1
          F(6)=HDD(J)
          E(6)=DBLE(ZD(KEYJ))
  460     DO 470 IJ=K,N
            DO 470 JK=L,M
              N1=2*(IJ-K)+1
              M1=2*(JK-L)+2
  470     UC=UC-(F(N1)*F(M1)-E(N1)*E(M1))*MAD(IJ,JK)
  480   M=M+1
  490 N=N+1
      A1=UB
      A2=UC
      A3=UB+UC
C
C Save MADELUNG terms for use in subroutine OUTPUT if doing the last
C cycle.
C
      K=1
      L=1
      DO 500 I=1,NA
        KEYI=KEY(I)
        MAD(K,K)=W(L)
        K=K+1
        L=L+1
        IF (NP(KEYI) .EQ. 0) GOTO 500
        MAD(K,K)=W(L)
        K=K+1
        L=L+3
        IF (ND(KEYI) .EQ. 0) GOTO 500
        MAD(K,K)=W(L)
        K=K+1
        L=L+5
  500 CONTINUE
C
C Show progress of iteration procedure.
C
  510 IF (PRTCYC .GT. 0) WRITE(6,520) ICYCLE
  520 FORMAT('0CYCLE NO.',I3,' ')
      IF (PRTCYC .LT. 0) WRITE(6,530)
  530 FORMAT('0CONVERGENCE REACHED-FINAL CYCLE FOLLOWS',///)
      PRTCYC=IABS(PRTCYC)
      J=NLF/10
      K=NLF-10*J
      WRITE(6,540) SUM,LAMBDA,J,ISIGNF,DENOM,ADJUST,K
  540 FORMAT('+',T25,'ENERGY =',F15.8,T52,'LAMBDA =',F8.5,T78,'ATOM =',
     .       I3,T92,'SIGN =',I3,/,T25,'DENOM =',D16.8,T52,'ADJUST =',
     .       D14.7,T78,'NL   =',I3)
C
C Print out atomic charges, orbital occupations, and corrected H(I,I)s
C if PRINTX is true.
C
      IF (.NOT. PRINTX) GOTO 660
      WRITE(6,550)
  550 FORMAT(////,T16,'ATOM',T30,'NET CHG.-DAMPED',T60,'SUMMED ORBITAL',
     .       ' OCCUPATIONS-DAMPED',/,T65,'S',T75,'P',T85,'D',/)
      DO 590 I=1,NA
        KEYI=KEY(I)
        UB=C(I)
        IF (NP(KEYI) .EQ. 0) THEN
          WRITE(6,560) SYMBOL(KEYI),I,UB,HSS(I)
  560     FORMAT(T15,A2,I3,T30,F10.5,T60,F10.5)
        ELSE
          IF (ND(KEYI) .EQ. 0) THEN
            WRITE(6,570) SYMBOL(KEYI),I,UB,HSS(I),HPP(I)
  570       FORMAT(T15,A2,I3,T30,F10.5,T60,2F10.5)
          ELSE
            WRITE(6,580) SYMBOL(KEYI),I,UB,HSS(I),HPP(I),HDD(I)
  580       FORMAT(T15,A2,I3,T30,F10.5,T60,3F10.5)
          ENDIF
        ENDIF
  590 CONTINUE
      WRITE(6,600)
  600 FORMAT(///,T16,'ATOM',T70,'CORRECTED H(I,I)''S',/,T40,'S',T50,'X',
     .       T60,'Y',T70,'Z',T80,'X2-Y2',T90,'Z2',T100,'XY',T110,'XZ',
     .       T120,'YZ',/)
      J=1
      DO 620 I=1,NATM
        KEYI=KEY(I)
        N=J
        IF (NP(KEYI) .NE. 0) N=J+3
        IF (ND(KEYI) .NE. 0) N=J+8
        WRITE(6,610) SYMBOL(KEYI),I,(H(K,K),K=J,N)
  610   FORMAT(T15,A2,I3,T35,9F10.5)
  620 J=N+1
      IF ((METH .GE. 3) .AND. (DABS(QON) .GT. 0.0001D0))
     .  WRITE(6,630) DGSUM
  630 FORMAT(///,T15,'AVERAGE SHIFT OF MO''S DUE TO NON-ZERO TOTAL ',
     .       'CHARGE =',F12.8,' EV')
      IF ((METH .GE. 3) .AND. (ICYCLE .EQ. MAXCYC))
     .  WRITE(6,640) A1,A2,A3
  640 FORMAT(///,T15,'ENERGY CORRECTIONS ',//,T20,'ONE-CENTER',T40,
     .       F16.8,' EV',//,T20,'TWO-CENTER',T40,F16.8,' EV',//,
     .       T20,'TOTAL',T40,F16.8,' EV')
      WRITE(6,650)
  650 FORMAT(///)
  660 ICYCLE=ICYCLE+1
C
C Check for convergence (ie. DENOM less than DELTAC).
C
      IF (ICYCLE .GE. MAXCYC) GOTO 670
      IF (ICYCLE .LE. 2) GOTO 670
      IF (DENOM .GE. DELTAC) GOTO 670
      ICYCLE=MAXCYC
      PRTCYC=-PRTCYC
  670 RETURN
      END
