C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE PEGLEF                                               *
C *                                                                  *
C *  Routine of ICONC                                                *
C *                                                                  *
C *  Usage......: Prints out fragment matrices in readable format.   *
C *                                                                  *
C *  Author.....: Charles Wilker (R. Hoffmann group)                 *
C *  Date.......: December 1981                                      *
C *  Revision...: last revision 20.11.90/mbs (Martin Braendle)       *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *  Remarks....: Adapted from BIGICON.                              *
C *                                                                  *
C *  Called from: OUTPUT                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE PEGLEF(A,N,NL,NC)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(NL,NL)

      NROW=N
      NCOL=NC
      KITE=0
20    LOW=KITE+1
      KITE=KITE+14
      IF (KITE.GT.NCOL) KITE=NCOL
      WRITE(6,1000) (I,I=LOW,KITE)
1000  FORMAT(/,7X,14I8,/)
      WRITE(6,1001)
1001  FORMAT( )
      DO 30 I=1,NROW
30      WRITE(6,1002) I,(A(I,J),J=LOW,KITE)
1002  FORMAT(' FRAG ',I1,2X,14F8.4)
      IF (KITE.LT.NCOL) GOTO 20
      WRITE(6,1003)
1003  FORMAT(/)
      RETURN
      END
