C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE ATOMREAD                                             *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: reads atom data defined in ATOMDEF                 *
C *                                                                  *
C *               Aufbau des externen Datenfiles 'ATOMDEF ':         *
C *               Pro Atom 4 Zeilen                                  *
C *                1. Zeile: SYMBOL (A3), IVELEC (I3)                *
C *                          Atomsymbol,  Valenzelektronen           *
C *                2. Zeile: NS (I3), EXPS (F6.4), COULS (F6.2)      *
C *                3. Zeile: NP (I3), EXPP (F6.4), COULP (F6.2)      *
C *                4. Zeile: ND (I3), EXPD (F6.4), COULD (F6.2),     *
C *                          C1 (F6.4), EXPD2 (F6.3), C2 (F6.4)      *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute of Inorganic and Physical Chemistry      *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM extended./mbs                   *
C *                                                                  *
C *  Called from: INPUTC                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE ATOMREAD
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      COMMON /CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM
 
      COMMON /PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .              L8,L9,PRT
      INTEGER NH,NA,KA,METH,IPRINT,IPUNCH
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      COMMON /ATDEF/IVELEC(MXSYMB),NS(MXSYMB),EXPS(MXSYMB),
     .              COULS(MXSYMB),NP(MXSYMB),EXPP(MXSYMB),COULP(MXSYMB),
     .              ND(MXSYMB),EXPD(MXSYMB),COULD(MXSYMB),C1(MXSYMB),
     .              EXPD2(MXSYMB),C2(MXSYMB)
      INTEGER IVELEC,NS,NP,ND
 
      OPEN (UNIT=1,FILE='ATOMDEF.DAT',STATUS='OLD')
      I=MXATOM+1
   10 IF (I .GT. MXSYMB) GOTO 90
      READ(1,20,END=60,ERR=70) SYMBOL(I),IVELEC(I)
   20 FORMAT(A3,I3)
      IF (SYMBOL(I) .EQ. '   ') GOTO 70
      IF (SYMBOL(I)(2:2) .EQ. ' ') THEN
        SYMBOL(I)(2:2)=SYMBOL(I)(1:1)
        SYMBOL(I)(1:1)=' '
      ENDIF
C
C make uppercase
C
      DO 30 II=1,2
        IF (ICHAR(SYMBOL(I)(II:II)) .GE. 97) THEN
          SYMBOL(I)(II:II)=CHAR(ICHAR(SYMBOL(I)(II:II))-32)
        ENDIF
   30 CONTINUE
      READ(1,40,END=70,ERR=70) NS(I),EXPS(I),COULS(I)
      READ(1,40,END=70,ERR=70) NP(I),EXPP(I),COULP(I)
   40 FORMAT(I3,F6.4,F6.2)
      READ(1,50,END=70,ERR=70) ND(I),EXPD(I),COULD(I),C1(I),
     . EXPD2(I),C2(I)
   50 FORMAT(I3,F6.4,F6.2,F6.4,F6.3,F6.4)
      I=I+1
      GOTO 10
   60 CLOSE (1)
      RETURN
   70 CLOSE (1)
      WRITE(6,80) SYMBOL(I-1)
   80 FORMAT($,' Definition of atoms in `ATOMDEF ` not correct',/,
     .       'Error after ',A3,' !')
      STOP ' Error in ATOMDEF.'
   90 CLOSE (1)
      WRITE(6,100) MXATMD
  100 FORMAT($,' `ATOMDEF ` contains more than ',I4,' atoms !',/)
      STOP ' ATOMDEF too big.'
      END
