C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE CASE1                                                *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: reads new data for generation of inputfile         *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM extended for FMO, k-parameter   *
C *               and omit-atom specification. /mbs                  *
C *                                                                  *
C *  Called from: INPUTC                                             *
C *                                                                  *
C *  Calls......: PAR                                                *
C *               HEAVY                                              *
C *               KOR                                                *
C *               INTKOR                                             *
C *               VARIN                                              *
C *               PARAMET                                            *
C *               OUTPUT                                             *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE CASE1(FILNAM)
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM
 
      COMMON/CONVERT/IVERK,IPARA,IADEF,IADD,IDUMMY,ISUM,IDIST,IVA
 
      COMMON/ITERAT/DAMP1,DAMP2,DAMP3,AMPRI,DELTAC,SENSE,MAXCYC,PRTCYC,
     .              NCON,JN,PARTIT
      INTEGER NCON,PRTCYC,MAXCYC
      LOGICAL PARTIT
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      CHARACTER*32 FILNAM
      CHARACTER*1 FR
 
      WRITE(6,10)
   10 FORMAT(/,' Title: ',$)
      READ(5,30,END=20) MNAM
   20 CONTINUE
   30 FORMAT(A80)
      CALL PAR
C
C liest Atomparameter, alle Atome werden wie Heavy Atoms behandelt
C (d.h. K = NA).
C
      K=NA
      CALL HEAVY(K)
      IF (IVA .EQ. 1) THEN
C
C liest kartesische Koordinaten
C
        CALL KOR(NA,SYMBOL)
      ELSE
        CALL INTKOR
        CALL VARIN
      ENDIF
   40 WRITE(6,50)
   50 FORMAT(//,' Do you want to define additional parameters? ','[N]',
     .       $)
      READ(5,60,ERR=40) FR
   60 FORMAT(A1)
      IF (INDEX('YyJj',FR) .GT. 0) THEN
        CALL PARAMET
      ENDIF
C
C bei Ladungsiteration an allen Atomen muessen saemtliche Atome
C definiert sein, d.h. IATOM muss ' *' enthalten
C
      IF ((METH .EQ. 2) .AND. ( .NOT. PARTIT)) THEN
        DO 70 I=1,NA+NH
          IATOM(I)=' *'
   70   CONTINUE
      ENDIF
C
C schreibt das fertige Datenfile
C
      CALL OUTPUT(K,FILNAM)
      RETURN
      END
