C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE CWKA                                                 *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads CWKA and CWKALP                              *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: 03.10.90/mbs                                       *
C *  Remarks....:                                                    *
C *                                                                  *
C *  Called from: PARAMET                                            *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE CWKA
      IMPLICIT REAL(A-H,O-Z)
 
      COMMON/NEWDI/CWK,CWKALP
 
      CHARACTER*1 YENO
 
   10 WRITE(6,20)
   20 FORMAT(/,' Default parameter  1+kappa = 2.00 : [Y] ',$)
      READ(5,30,ERR=10) YENO
   30 FORMAT(A1)
      IF (INDEX('Nn',YENO) .GT. 0) THEN
   40   WRITE(6,50)
   50   FORMAT($,'  1+kappa   (1.4 to 2.5) ..........: ')
        READ(5,*,ERR=40) CWK
        IF (CWK .LT. 1.4) GOTO 40
        IF (CWK .GT. 2.5) GOTO 40
      ELSE
        CWK=2.0
      ENDIF
   60 WRITE(6,70)
      READ(5,30,ERR=60) YENO
   70 FORMAT($,' Default parameter    delta = 0.35 : [Y] ')
      IF (INDEX('Nn',YENO) .GT. 0) THEN
   80   WRITE(6,90)
        READ(5,*,ERR=80) CWKALP
   90 FORMAT($,'  delta  (0.0 to 1.0) ..........: ')
        IF (CWKALP .LT. 0.0) GOTO 80
        IF (CWKALP .GT. 1.0) GOTO 80
      ELSE
        CWKALP=0.35
      ENDIF
      RETURN
      END
