C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE GENIC (originally PROGRAM GENINS)                    *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Varies internal coordinates.                       *
C *                                                                  *
C *                                                                  *
C *  WRITTEN : - ROALD HOFFMANN, CORNELL UNIVERSITY, USA, 1975 (?)   *
C *              (UNPUBLISHED PROGRAM)                               *
C *                                                                  *
C *  ORIGIN  : - CYBER 175 VERSION OF P. HOFMANN, MUENCHEN-GARCHING  *
C *              FORTRAN IV, OCT 1984, PROGRAM SGEN                  *
C *                                                                  *
C *  VERSION : - IBM VERSION 1.4                                     *
C *            - ADAPTATIONS FOR IBM-PC COMPATIBLES                  *
C *              MICROSOFT FORTRAN COMPILER VERSION 4.10             *
C *              TH. HUGENTOBLER, APRIL & AUGUST 1989                *
C *              INST. FOR INORG. CHEMISTRY, UNIVERSITY CH-3012 BERN *
C *                                                                  *
C *  CHANGES : - #1, TH 1.4                                          *
C *            - WITHOUT COMMENT-OUTPUT (NO WRITE((6,...)) 5.9.89 TH *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Institute of Inorganic and Physical Chemistry      *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: 15.05.92/rr                                        *
C *  Remarks....: MOBYC added as LOOPCOUNTER. MOBYC returns          *
C *               as value how many times the first line of          *
C *               the original input file is printed out. Doing      *
C *               so, the name for the MOBY OUTPUT FILE can be added *
C *               only at the end of the file where this infor-      *
C *               mation will be needed in ICONC (ROUTINE MOBY.FOR). *
C *                                                                  *
C *  Called from: INPUTC                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
C
      SUBROUTINE GENIC (FILEI,FILEO,MOBYC)
 
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INCLUDE 'inpupara.for'
 
      DOUBLE PRECISION INCR(MXVAR)
      CHARACTER*32     FILEI,FILEO
      CHARACTER*80     TITLE,ICON,FMO,TXTLINE(MXATOM)
      CHARACTER*78     CARDAD(MXATOM)
      CHARACTER*2      LINK(MXVAR),STAR,ATCARD(MXATOM),ATDEF(MXATOM),
     .                 BTCARD(MXATOM)
 
      DIMENSION IAT1(MXATOM),IAT2(MXATOM),INDEX(MXVAR),CARD(3,MXATOM),
     .          ICARD(MXVAR),ICOORD(MXVAR),START(MXVAR),IRUN(MXVAR),
     .          IVCOORD(MXVAR),IVCARD(MXVAR)
C
C UNIT 5 FOR INPUT-FILE
C
      OPEN (UNIT=5,FILE=FILEI)
C
C UNIT 7 FOR OUTPUT-FILE
C
      OPEN(UNIT=7,FILE=FILEO,STATUS='UNKNOWN')
      STAR=' *'
      IFIRST=1
      WRITE(6,10) FILEI,FILEO
   10 FORMAT(/,' Variation of Internal Coordinates from ',A32,/,
     .       ' to File ',A32,/,' .....',$)
C
C #1,   NEW PARAMETER NPLUS FOR NUMBER OF ADDITIONAL LINES AFTER
C       PARAMETER CARDS, E.G. FOR USER-DEFINED ORBITAL OCCUPTION
C
      READ(5,20) NC,NPARM,NADD,NPLUS
   20 FORMAT(4I4)
      IF (NC .GE. MXATOM) STOP 'MAX. NUMBER OF BOND DEF. CARDS EXCEEDED'
      IF (NPARM .GE. MXVAR) STOP
     . 'MAX. NUMBER OF PARAMETER CARDS EXCEEDED'
      IF (NADD .GE. MXATOM) STOP 'MAX. NUMBER OF HEAVY ATOMS EXCEEDED'
      IF (NPLUS .GT. MXATOM) STOP 'MAX. NUMBER OF ADDED CARDS EXCEEDED'
C
C READ PARAMETERS FOR CONVERT
C
      READ(5,30) NCONV,NDROP,NORD,NDIST
   30 FORMAT(4I4)
C
C #1, TEST FOR CORRECT NUMBER OF ADDITIONAL CARDS FOR CONVERT
C
      IF ((NADD+NPLUS) .NE. NORD) NORD=NADD+NPLUS
C
C READ TITLE-CARD
C
      READ(5,40) TITLE
C
C READ PARAMETERS FOR ICON
C
      READ(5,40) ICON
      READ(ICON,'(3X,I3)') NA
C
C READ PARAMETERS FOR FMO (obsolete)
C
      READ(5,40) FMO
   40 FORMAT(A80)
C
C READ GEOMETRY DEFINITION CARDS
C
      DO 60 J=1,NC
        READ(5,50) IAT1(J),IAT2(J),(CARD(I,J),I=1,3)
   50 FORMAT(I3,1X,I3,3F10.5)
   60 CONTINUE
C
C READ ATOM DEFINITON CARD
C
      READ(5,70) (ATCARD(I),I=1,NA)
   70 FORMAT(40A2)
      DO 80 I=1,NA
        BTCARD(I)=ATCARD(I)
   80 CONTINUE
C
C READ ADDITIONAL CARDS (IF ANY) AND DO SOME CONVERSION
C
      IF (NADD .NE. 0) THEN
        READ(5,90) (ATDEF(I),CARDAD(I),I=1,NADD)
   90   FORMAT(A2,A78)
        INADD=1
        DO 100 I=1,NA
          BTCARD(I)=ATCARD(I)
          IF (BTCARD(I) .EQ. ' *') THEN
            BTCARD(I)=ATDEF(INADD)
            INADD=INADD+1
          ENDIF
  100   CONTINUE
        NORD1=NORD-NADD
      ENDIF
C
C #1,   READ ADDITIONAL LINES AFTER PARAMETER CARDS
C
      IF (NPLUS .GT. 0) THEN
        READ(5,40) (TXTLINE(I),I=1,NPLUS)
      ENDIF
C
C READ PARAMETERS FOR VARIATION
C
      READ(5,110) (IRUN(K),LINK(K),ICARD(K),ICOORD(K),INCR(K),K=1,NPARM)
  110 FORMAT(I3,A2,2I3,F10.6)
C
C WRITE ALL OUT  -- DELETED CODE
C
      NPARM1=NPARM+1
C
C *** TEST FOR NUMBER (L) OF UNLINKED SETS
C
      L=1
      DO 120 K=1,NPARM
        INDEX(K)=1
        I=ICOORD(K)
        J=ICARD(K)
        START(K)=CARD(I,J)
        IF (LINK(K) .EQ. STAR) GOTO 120
        IVCOORD(L)=I
        IVCARD(L)=J
        L=L+1
  120 CONTINUE
      LTOT=L-1
      IVAR=1
      GOTO 150
  130 L=L+2
      DO 140 K=NZERO,NPARM
        INDEX(K)=1
        I=ICOORD(K)
        J=ICARD(K)
        CARD(I,J)=START(K)
        IF (LINK(K) .EQ. STAR) GOTO 140
        L=L+1
  140 CONTINUE
  150 CONTINUE
      IF (IFIRST .EQ. 1) THEN
        WRITE(7,30) NCONV,NDROP,NORD,NDIST
      ELSE
        WRITE(7,30) NCONV,NDROP,NORD1,NDIST
      ENDIF
C
C #1,  WRITE VALUES OF FIRST TWO INDEPENDENTLY CHANGED
C      (=UNLINKED) PARAMETERS INTO TITLE CARD
C
      IF (LTOT .GT. 1) THEN
        WRITE(7,160) TITLE,CARD(IVCOORD(1),IVCARD(1)),
     .               CARD(IVCOORD(2),IVCARD(2))
      ELSE
        WRITE(7,170) TITLE,CARD(IVCOORD(1),IVCARD(1))
      ENDIF
  160 FORMAT(A52,2X,F8.3,1X,F8.3)
  170 FORMAT(A61,2X,F8.3)
 
      WRITE(7,40) ICON,FMO
      MOBYC=MOBYC+1
      WRITE(7,50) (IAT1(J),IAT2(J),(CARD(I,J),I=1,3),J=1,NC)
      IF (IFIRST .EQ. 1) THEN
        WRITE(7,70) (ATCARD(I),I=1,NA)
        IF (NADD .NE. 0) WRITE(7,90) (ATDEF(I),CARDAD(I),I=1,NADD)
        IFIRST=0
      ELSE
        WRITE(7,70) (BTCARD(I),I=1,NA)
      ENDIF
C
C #1,   WRITE ADDITIONAL LINES AFTER PARAMETER CARDS
C
      IF (NPLUS .GT. 0) THEN
        WRITE(7,40) (TXTLINE(I),I=1,NPLUS)
      ENDIF
 
      L=LTOT
      DO 200 K=1,NPARM
        NINC=NPARM1-K
        I=ICOORD(NINC)
        J=ICARD(NINC)
        CARD(I,J)=CARD(I,J)+INCR(NINC)
        INDEX(NINC)=INDEX(NINC)+1
        IF (LINK(NINC) .EQ. STAR) THEN
          TEMP=CARD(I,J)-ABS(INCR(NINC))
C          WRITE((6,2002) IVAR,TEMP
C 2002      FORMAT(3X,I3,5X,F10.5)
          IVAR=IVAR+1
          GOTO 180
        ENDIF
        L=L-1
  180   CONTINUE
        IF (LINK(NINC) .EQ. STAR) GOTO 200
        IF (INDEX(NINC) .GT. IRUN(NINC)) GOTO 200
        IF (INDEX(NPARM) .LE. IRUN(NPARM)) GOTO 150
        NZERO=NINC+1
  190   IF (LINK(NZERO) .NE. STAR) GOTO 130
        NZERO=NZERO+1
        GOTO 190
  200 CONTINUE
      CLOSE (UNIT=5)
      CLOSE (UNIT=7)
      WRITE(6,210)
  210 FORMAT(' finished')
      RETURN
      END
