C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE HEAVY                                                *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: reads heavy atom card                              *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM extended./mbs                   *
C *                                                                  *
C *  Called from: CASE1                                              *
C *                                                                  *
C *  Calls......: HEVIN                                              *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE HEAVY(K)
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      CHARACTER*2 V(3),IV
 
      COMMON/ATDEF/IVELEC(MXSYMB),NS(MXSYMB),EXPS(MXSYMB),COULS(MXSYMB),
     .             NP(MXSYMB),EXPP(MXSYMB),COULP(MXSYMB),ND(MXSYMB),
     .             EXPD(MXSYMB),COULD(MXSYMB),C1(MXSYMB),EXPD2(MXSYMB),
     .             C2(MXSYMB)
 
      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      EQUIVALENCE (IV,V)
 
      K=NA
      DO 10 I=1,NA+NH
        IATOM(I)=' *'
   10 CONTINUE
      WRITE(6,20)
   20 FORMAT(//,' Definition of atoms ',/,' ******************* ',//,'
     .The following atoms are already defined: ',/)
C
C sucht Index IMAX des letzten definierten Atoms
C
      IMAX=MXATOM
   30 IMAX=IMAX+1
      IF ((IMAX .LE. MXSYMB) .AND. (SYMBOL(IMAX) .NE. '***')) GOTO 30
      IMAX=IMAX-1
      WRITE(6,40) (SYMBOL(I),I=MXATOM+1,IMAX)
   40 FORMAT(1X,19A4)
      WRITE(6,50)
   50 FORMAT(/,' For these atoms simply enter the symbol, e.g. `NA`',/,
     .       ' For every atom not in the list enter `*`. ',/)
      L=0
      I=1
   60 IF (I .GT. NA) GOTO 190
      WRITE(6,70) I
   70 FORMAT($,' Atom #',I3,': ',$)
      READ(5,80) SYMBOL(I)
   80 FORMAT(A3)
      IF (SYMBOL(I)(2:2) .EQ. ' ') THEN
        SYMBOL(I)(2:2)=SYMBOL(I)(1:1)
        SYMBOL(I)(1:1)=' '
      ENDIF
C
C make uppercase
C
      DO 90 II=1,2
        IF (ICHAR(SYMBOL(I)(II:II)) .GE. 97) THEN
          SYMBOL(I)(II:II)=CHAR(ICHAR(SYMBOL(I)(II:II))-32)
        ENDIF
   90 CONTINUE
      IF (SYMBOL(I) .EQ. ' *') GOTO 140
C
C Test, ob Atomname intern schon definiert ist
C
C   ii ist Laufzahl fuer Suche durch DATA-Bestand
C   IDEFU ist Flag, wenn Atom schon eingegeben wurde
C   IDEF  ist Flag, wenn Atom definiert ist
C
      IDEF=0
      IDEFU=0
C
C sucht, ob Atomname schon eingegeben wurde (Elemente I-1 bis 1)
C
      II=I-1
  100 IF (II .GT. 0) THEN
        IF (SYMBOL(II) .EQ. SYMBOL(I)) THEN
          IDEFU=1
          IDEF=1
          IATOM(I)=SYMBOL(II)
          IVELEC(I)=IVELEC(II)
          NS(I)=NS(II)
          EXPS(I)=EXPS(II)
          COULS(I)=COULS(II)
          NP(I)=NP(II)
          EXPP(I)=EXPP(II)
          COULP(I)=COULP(II)
          ND(I)=ND(II)
          EXPD(I)=EXPD(II)
          COULD(I)=COULD(II)
          C1(I)=C1(II)
          C2(I)=C2(II)
          EXPD2(I)=EXPD2(II)
          II=1
        ELSE
          II=II-1
          GOTO 100
        ENDIF
      ENDIF
C
C Wenn Atomname noch nicht vorgekommen ist, dann im DATA-Bereich
C von ATOMDEF  suchen (Elemente 101 bis 250)
C
      IF (IDEFU .EQ. 0) THEN
        II=MXATOM+1
  110   IF (II .LE. MXSYMB) THEN
          IF (SYMBOL(II) .EQ. SYMBOL(I)) THEN
            IDEF=1
            IVELEC(I)=IVELEC(II)
            NS(I)=NS(II)
            EXPS(I)=EXPS(II)
            COULS(I)=COULS(II)
            NP(I)=NP(II)
            EXPP(I)=EXPP(II)
            COULP(I)=COULP(II)
            ND(I)=ND(II)
            EXPD(I)=EXPD(II)
            COULD(I)=COULD(II)
            C1(I)=C1(II)
            C2(I)=C2(II)
            EXPD2(I)=EXPD2(II)
            II=251
          ELSE
            II=II+1
            GOTO 110
          ENDIF
        ENDIF
      ENDIF
 
      IF (IDEF .EQ. 1) GOTO 180
      WRITE(6,120) SYMBOL(I)
  120 FORMAT(/,' Warning: ',A3,' is undefined! ',/,
     .       ' Use symbol out of list or enter `*` ',/)
      WRITE(6,40) (SYMBOL(II),II=MXATOM+1,IMAX)
      WRITE(6,130)
  130 FORMAT(/)
      GOTO 60
C
C  Neudefinition, nachdem '*' eingegeben wurde
C
  140 CONTINUE
      CALL HEVIN(I)
      L=NA-I+1
  150 WRITE(6,160)
  160 FORMAT($,' How many atoms of this type: ')
      READ(5,*,ERR=150) LF
      IF (LF .GT. L) GOTO 150
      L=L-LF
  170 LF=LF-1
      IF (LF .GT. 0) THEN
        I=I+1
        SYMBOL(I)=SYMBOL(I-1)
        IATOM(I)=SYMBOL(I)
        IVELEC(I)=IVELEC(I-1)
        NS(I)=NS(I-1)
        EXPS(I)=EXPS(I-1)
        COULS(I)=COULS(I-1)
        NP(I)=NP(I-1)
        EXPP(I)=EXPP(I-1)
        COULP(I)=COULP(I-1)
        ND(I)=ND(I-1)
        EXPD(I)=EXPD(I-1)
        COULD(I)=COULD(I-1)
        C1(I)=C1(I-1)
        C2(I)=C2(I-1)
        EXPD2(I)=EXPD2(I-1)
        GOTO 170
      ENDIF
  180 I=I+1
      GOTO 60
  190 CONTINUE
      RETURN
      END
