C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE ITRATE                                               *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: reads charge iteration parameters                  *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM extended./mbs                   *
C *                                                                  *
C *  Called from: PARAMET                                            *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE ITRATE
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      CHARACTER   FR
C      CHARACTER*2 V(3),IV
 
      COMMON/CHART/MNAM,IATOM(MXATOM),SYMBOL(MXSYMB),ITAT(MXITER)
      CHARACTER*2  IATOM
      CHARACTER*3  SYMBOL,ITAT
      CHARACTER*80 MNAM
 
      COMMON/ITERAT/DAMP1,DAMP2,DAMP3,AMPRI,DELTAC,SENSE,MAXCYC,PRTCYC,
     .              NCON,JN,PARTIT
      INTEGER NCON,PRTCYC,MAXCYC
      LOGICAL PARTIT
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
C      EQUIVALENCE (IV,V)
C no longer needed 
C 15.12.95 /Ruedi Rytz
 
      METH=2
   10 FORMAT(A1)
   20 WRITE(6,30)
   30 FORMAT(/,' A: 3 VSIE-parameters',/,
     .         ' B: 9 VSIE-parameters (for d-Elements)',/,
     .         ' Method: ',$)
      READ(5,10,ERR=20) FR
      NCON=0
      IF (INDEX('Aa',FR) .GT. 0) THEN
        NCON=1
      ELSE IF (INDEX('Bb',FR) .GT. 0) THEN
        NCON=3
      ENDIF

      ITMAX=MXITER
      IF (NA .LT. ITMAX) ITMAX=NA

      IF (NCON .EQ. 0) GOTO 20
   40 WRITE(6,50)
   50 FORMAT(' A: Charge iteration on all atoms',/,
     .       ' B: Charge iteration on selected atoms only',/,
     .       ' Method: ',$)
      READ(5,10,ERR=40) FR
      IF (INDEX('Aa',FR) .GT. 0) THEN
        PARTIT=.FALSE.
      ELSE IF (INDEX('Bb',FR) .GT. 0) THEN
        PARTIT=.TRUE.
      ELSE
        GOTO 40
      ENDIF
      IF (PARTIT) THEN
   60   WRITE(6,70) ITMAX
   70   FORMAT($,' Iteration on how many atoms (max.',I2,'): ',$)
        READ(5,*,ERR=60) JN
        IF (JN .GT. ITMAX) GOTO 60
        WRITE(6,80) NA
   80   FORMAT(/,' The molecule contains the following ',I3,' atoms: ')
        WRITE(6,90) (SYMBOL(II),II=1,NA)
   90   FORMAT(1X,19A4)
        DO 200 I=1,JN
  100     WRITE(6,110) I
  110     FORMAT($,' Symbol ',I2,$,': ')
          READ(5,120,ERR=100) ITAT(I)
  120     FORMAT(A3)
C
C make uppercase
C
          DO 130 II=1,2
            IF (ICHAR(ITAT(I)(II:II)) .GE. 97) THEN
              ITAT(I)(II:II)=CHAR(ICHAR(ITAT(I)(II:II))-32)
            ENDIF
  130     CONTINUE
          IF (ITAT(I)(2:2) .EQ. ' ') THEN
            ITAT(I)(2:2)=ITAT(I)(1:1)
            ITAT(I)(1:1)=' '
          ENDIF
          DO 140 II=1,ITMAX
            IF (ITAT(I) .EQ. SYMBOL(II)) GO TO 200
  140     CONTINUE
          WRITE(6,150) ITAT(I), ITMAX
  150     FORMAT(/,' Warning: ',A3,' is not defined within the first ',
     .           I3,' atoms ',/,' =======')
          IF (NA .GT. ITMAX) THEN
            DO 160 II=ITMAX,NA
              IF (ITAT(I) .EQ. SYMBOL(II)) GOTO 180
  160       CONTINUE
          ENDIF
          WRITE(6,170)
  170     FORMAT(' and is not contained in this molecule, please ',
     .           'reenter!')
          GOTO 100
  180     WRITE(6,190)
  190     FORMAT(' The order of the symbol has to be rearranged in the',
     .           ' editor',/,' before running ICONC.',/)
  200   CONTINUE
      ENDIF
      DAMP1=0.1
      DAMP2=0.1
      DAMP3=0.0
      AMPRI=0.1
      DELTAC=0.005
      SENSE=0.5
      MAXCYC=100
      PRTCYC=20
  210 WRITE(6,220)
  220 FORMAT(/,' Default parameters for charge iteration: [Y] ',$)
      READ(5,10,ERR=210) FR
      IF (INDEX('Nn',FR) .GT. 0) THEN
        WRITE(6,230)
  230   FORMAT(//,' Which of the following parameters do you want to ',
     .         'change?',/,
     .   ' Default values are in ( )                               ',//,
     .   '  1  DAMP1   0 < DAMP1 < LAMPRI                     (0.1)',/,
     .   '  2  DAMP2   0 < DAMP2 < LAMPRI                     (0.1)',/,
     .   '  3  DAMP3   0 < DAMP3 < 1                          (0.0)',/,
     .   '  4  LAMPRI  If the charge dependence is high,           ',/,
     .   '             LAMPRI should be small (LAMPRI < 0.1)       ',/,
     .   '             For reduced charge dependences a larger     ',/,
     .   '             value of LAMPRI may be used.           (0.1)',/,
     .   '  5  DELTAC  Criterium of convergence             (0.001)',/,
     .   '  6  MAXCYC  Max. number of cycles of iteration     (100)',/,
     .   '  7  PRTCYC  Report after # of cycles                (20)',/,
     .   '  8  Continue',//)
  240   WRITE(6,250)
  250   FORMAT($,' Parameter # : ')
        READ(5,*,ERR=240) MQ
  260   WRITE(6,270)
  270   FORMAT($,' New value ..: ')
        IF (MQ .EQ. 1) READ(5,*,ERR=260) DAMP1
        IF (MQ .EQ. 2) READ(5,*,ERR=260) DAMP2
        IF (MQ .EQ. 3) READ(5,*,ERR=260) DAMP3
        IF (MQ .EQ. 4) READ(5,*,ERR=260) AMPRI
        IF (MQ .EQ. 5) READ(5,*,ERR=260) DELTAC
        IF (MQ .EQ. 6) READ(5,*,ERR=260) MAXCYC
        IF (MQ .EQ. 7) READ(5,*,ERR=260) PRTCYC
        IF (MQ .GT. 7) GOTO 280
        GOTO 240
  280   CONTINUE
      ENDIF
      RETURN
      END
