C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  KSPEC                                                           *
C *                                                                  *
C *  Routine of INPUTC,                                              *
C *                                                                  *
C *  Usage......: specifies k for several atom pairs.                *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 24.06.91, by Martin Braendle (mbs)                 *
C *  Revision...: 17.10.91/mbs                                       *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: PARAMET                                            *
C *                                                                  *
C *  Calls......: CWKA                                               *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE KSPEC
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
 
      COMMON/KSET/KATOM(MXSETK,2),SETK(MXSETK),SETD(MXSETK),NKSET
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      IF (IPUNCH .NE. 1) THEN
        WRITE(6,10)
   10   FORMAT(//,' First specify global 1+kappa and delta values',
     .            ' (option #1):')
        CALL CWKA
        IPUNCH=1
      ENDIF
 
      WRITE(6,20) MXSETK
   20 FORMAT(//,' 1+kappa and delta-parameter specifications (max.',I3,
     .       'values).')
      WRITE(6,30)
   30 FORMAT(/,' Enter atom pair and parameters (with dec. point).',/,
     .         ' Example: atom atom 1+kappa   delta',/,
     .         '          1    3    1.75      0.4',/,
     .         ' Exit with an empty line!')
   40 FORMAT(BN,9X,' atom atom 1+kappa   delta',/,$,4X,I3,$,' : ')
   50 FORMAT(BN,I5,I5,2F10.5)
      NKSET=1
   60 WRITE(6,40) NKSET
      READ(5,50,ERR=60) IATOM1,IATOM2,SETK(NKSET),SETD(NKSET)
      IF (IATOM1 .GT. 0) THEN
        IF ((IATOM1 .EQ. IATOM2) .OR. (IATOM1 .GT. NA) .OR.
     .      (IATOM2 .GT. NA) .OR. (IATOM2 .LT. 1)) GOTO 60
        IF (NKSET .GT. 1) THEN
          DO 70 I=1,NKSET-1
            IF (((IATOM1 .EQ. KATOM(I,1)) .AND.
     .           (IATOM2 .EQ. KATOM(I,2))) .OR.
     .          ((IATOM1 .EQ. KATOM(I,2)) .AND.
     .           (IATOM2 .EQ. KATOM(I,1)))) GOTO 60
   70     CONTINUE
        ENDIF
        KATOM(NKSET,1)=IATOM1
        KATOM(NKSET,2)=IATOM2
        NKSET=NKSET+1
        IF (NKSET .LE. MXSETK) GOTO 60
      ENDIF
      NKSET=NKSET-1
      L7=(NKSET .NE. 0)
      RETURN
      END
