C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE ORBSUB                                               *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: for change of level occupation                     *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 01.06.92/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM changed./mbs                    *
C *               User specified atomic electron configaration added.*
C *               01.06.92/mbs                                       *
C *                                                                  *
C *  Called from: PARAMET                                            *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE ORBSUB(K3,KELE)
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      COMMON/AOOCC/NAOOCC,ICONF(MXAOOC,4)
 
      COMMON/ORBES/BES(MXORB),ODD(MXODD),KL,K2
      INTEGER BES,KL,K2
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      WRITE(6,10)
   10 FORMAT(/,'    ***************************************',/,
     .         '    * 1 Set MO level occupation           *',/,
     .         '    * 2 Set atomic electron configuration *',/,
     .         '    * 0 Exit                              *',/,
     .         '    ***************************************',/)
   20 WRITE(6,30)
   30 FORMAT(' Selection: ',$)
      READ(5,40,ERR=20) ISEL
   40 FORMAT(I2)
      IF (ISEL .EQ. 1) THEN
        L1=.TRUE.
   50   ANZELE=0.0
        WRITE(6,60) K3,KELE
   60   FORMAT(/,' The molecule contains ',I3,' orbitals',' with ',I3,
     .           ' electrons.',/)
   70   WRITE(6,80)
   80   FORMAT($,' Number of double occupied MOs ......: ')
        READ(5,*,ERR=70) K
        KL=K
        DO 90 I=1,K
          BES(I)=2
          ANZELE=ANZELE+2.0
   90   CONTINUE
  100   WRITE(6,110)
  110   FORMAT($,' Number of single occupied MOs: ')
        READ(5,*,ERR=100) K1
        IF (K1 .GT. 0) THEN
          DO 120 I=1,K1
            BES(KL+I)=1
            ANZELE=ANZELE+1.0
  120     CONTINUE
          KL=KL+K1
        ENDIF
        KNGANZ=K3-KL
        IF (KNGANZ .GT. 0) THEN
          IF (KNGANZ .GT. MXODD) KNGANZ=MXODD
  130     WRITE(6,140) KNGANZ
  140     FORMAT($,' Number of MOs (max.',I2,') with non-integer ',
     .             'occupation: ',$)
          READ(5,*,ERR=130) K2
          IF (K2 .GT. KNGANZ) GOTO 130
          IF (K2 .GT. 0) THEN
            DO 170 I=1,K2
              BES(KL+I)=3
  150         WRITE(6,160) (KL+I)
  160         FORMAT($,' Occupation of ',I3,$,'-th MO ......: ')
              READ(5,*,ERR=150) ODD(I)
              ANZELE=ANZELE+ODD(I)
  170       CONTINUE
            KL=KL+K2
          ENDIF
        ENDIF
        IF (KNGANZ .LT. 0) THEN
          WRITE(6,180)
  180     FORMAT(/,' Too many orbitals occupied, *** Please reenter',/)
          DO 190 I=1,KL
            BES(I)=0
  190     CONTINUE
          GOTO 50
        ENDIF
        IF (ABS(ANZELE-KELE) .GT. 0.001) THEN
          WRITE(6,200) ANZELE,KELE
  200     FORMAT(/,' Wrong number of electrons: ',F7.4,' of ',I3,
     .             ' electrons used',/,' *******  Please reenter',/)
          DO 210 I=1,KL
            BES(I)=0
  210     CONTINUE
          GOTO 50
        ENDIF
      ELSE IF (ISEL .EQ. 2) THEN
        WRITE(6,220)
  220   FORMAT(/,' Change of atomic electron configuration. ',/,
     .           ' Be careful, the total number of electrons will not ',
     .           'be checked.',/,
     .           ' For exitting enter an empty line at atom number ',
     .           'input.')
        L9=.TRUE.
        NAOOCC=0
  230   WRITE(6,240)
  240   FORMAT(/,' Number of atom: ',$)
        READ(5,250,ERR=230) NCHANG
  250   FORMAT(I3)
        IF ((NCHANG .LT. 0) .OR. (NCHANG .GT. NA)) GOTO 230
        IF (NCHANG .GT. 0) THEN
          IF (NAOOCC .GT. 0) THEN
            DO 260 I=1,NAOOCC
              IF (NCHANG .EQ. ICONF(I,1)) GOTO 270
  260       CONTINUE
          ENDIF
          NAOOCC=NAOOCC+1
          ICONF(NAOOCC,1)=NCHANG
  270     IS=0
          WRITE(6,280)
  280     FORMAT(' Number of s electrons: ',$)
          READ(5,290,ERR=270) IS
  290     FORMAT(I1)
          IF ((IS .LT. 0) .OR. (IS .GT. 2)) GOTO 270
          ICONF(NAOOCC,2)=IS
  300     IP=0
          WRITE(6,310)
  310     FORMAT(' Number of p electrons: ',$)
          READ(5,320,ERR=300) IP
  320     FORMAT(I1)
          IF ((IP .LT. 0) .OR. (IP .GT. 6)) GOTO 300
          ICONF(NAOOCC,3)=IP
  330     ID=0
          WRITE(6,340)
  340     FORMAT(' Number of d electrons: ',$)
          READ(5,350,ERR=330) ID
  350     FORMAT(I2)
          IF ((ID .LT. 0) .OR. (ID .GT. 10)) GOTO 330
          ICONF(NAOOCC,4)=ID
          IF (NAOOCC .LT. MXAOOC) GOTO 230
        ENDIF
      ENDIF
      RETURN
      END
